"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("@polkadot/types/injector");

var _testingPairs = _interopRequireDefault(require("@polkadot/keyring/testingPairs"));

var _util = require("@polkadot/util");

var _static = _interopRequireDefault(require("../static"));

// Copyright 2017-2019 @polkadot/api-metadata authors & contributors
// This software may be modified and distributed under the terms
// of the Apache-2.0 license. See the LICENSE file for details.
const keyring = (0, _testingPairs.default)({
  type: 'ed25519'
});
describe('fromMetadata', () => {
  it('should throw if the storage function expects an argument', () => {
    expect(() => _static.default.balances.freeBalance()).toThrowError(/requires one argument/);
  });
  it('should return a value if the storage function does not expect an argument', () => {
    expect(() => _static.default.timestamp.now()).not.toThrow();
  });
  it('should return the correct length-prefixed storage key', () => {
    expect((0, _util.u8aToHex)(_static.default.balances.freeBalance(keyring.alice.address))).toEqual('0x807f864e18e3dd8b58386310d2fe0919eef27c6e558564b7f67f22d99d20f587bb');
  });
});