"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("../injector");

var _create = require("../codec/create");

var _Bytes = _interopRequireDefault(require("./Bytes"));

// Copyright 2017-2019 @polkadot/types authors & contributors
// This software may be modified and distributed under the terms
// of the Apache-2.0 license. See the LICENSE file for details.
describe('Bytes', () => {
  const CODE = new Uint8Array([0x14, 0x3a, 0x63, 0x6f, 0x64, 0x65]);
  describe('construction', () => {
    it('decodes when input is string', () => {
      expect(new _Bytes.default(':code').toU8a()).toEqual(CODE);
    });
    it('decodes when hex is not length prefixed', () => {
      expect(new _Bytes.default('0x3a636f6465').toU8a()).toEqual(CODE);
    });
    it('decodes from number[]', () => {
      expect(new _Bytes.default([0x3a, 0x63, 0x6f, 0x64, 0x65]).toU8a()).toEqual(CODE);
    });
    it('creates via storagedata (no prefix)', () => {
      expect(new _Bytes.default((0, _create.createType)('StorageData', '0x3a636f6465')).toU8a()).toEqual(CODE);
    });
  });
});