"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("../../injector");

var _Metadata = _interopRequireDefault(require("../../Metadata"));

var _static = _interopRequireDefault(require("../../Metadata/static"));

var _SignedBlock = _interopRequireDefault(require("../../json/SignedBlock.003.00.json"));

var _Call = _interopRequireDefault(require("./Call"));

var _Block = _interopRequireDefault(require("./Block"));

// Copyright 2017-2019 @polkadot/types authors & contributors
// This software may be modified and distributed under the terms
// of the Apache-2.0 license. See the LICENSE file for details.
describe('Block', () => {
  beforeEach(() => {
    _Call.default.injectMetadata(new _Metadata.default(_static.default));
  });
  it('has a valid toRawType', () => {
    expect(new _Block.default().toRawType()).toEqual( // each of the containing structures have been stringified on their own
    JSON.stringify({
      header: JSON.stringify({
        parentHash: 'H256',
        number: 'Compact<u32>',
        stateRoot: 'H256',
        extrinsicsRoot: 'H256',
        digest: JSON.stringify({
          logs: 'Vec<{"_enum":{"Other":"Bytes","AuthoritiesChange":"Vec<AccountId>","ChangesTrieRoot":"H256","SealV0":"(u64,H512)","Consensus":"(u32,Bytes)","Seal":"(u32,Bytes)","PreRuntime":"(u32,Bytes)"}}>'
        })
      }),
      extrinsics: 'Vec<Extrinsic>'
    }));
  });
  it('re-encodes digest items correctly', () => {
    const digest = new _Block.default(_SignedBlock.default.result.block).header.digest;
    expect(digest.logs[0].toHex()).toEqual(_SignedBlock.default.result.block.header.digest.logs[0]);
    expect(digest.logs[1].toHex()).toEqual(_SignedBlock.default.result.block.header.digest.logs[1]);
  });
});